Index: drivers/filesystems/btrfs/btrfs.c
===================================================================
--- drivers/filesystems/btrfs/btrfs.c	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs.c	(copie de travail)
@@ -4587,151 +5169,308 @@
         char* dateline;
         LARGE_INTEGER time;
         TIME_FIELDS tf;
-        
+
         InitializeObjectAttributes(&oa, &log_file, OBJ_CASE_INSENSITIVE | OBJ_KERNEL_HANDLE, NULL, NULL);
-        
+
         Status = ZwCreateFile(&log_handle, FILE_WRITE_DATA, &oa, &iosb, NULL, FILE_ATTRIBUTE_NORMAL, FILE_SHARE_READ,
                               FILE_OPEN_IF, FILE_NON_DIRECTORY_FILE | FILE_WRITE_THROUGH | FILE_SYNCHRONOUS_IO_ALERT, NULL, 0);
-        
+
         if (!NT_SUCCESS(Status)) {
             ERR("ZwCreateFile returned %08x\n", Status);
-            return;
+            goto end;
         }
-        
+
         if (iosb.Information == FILE_OPENED) { // already exists
             FILE_STANDARD_INFORMATION fsi;
             FILE_POSITION_INFORMATION fpi;
-            
+
             static char delim[] = "\n---\n";
-            
+
             // move to end of file
-            
+
             Status = ZwQueryInformationFile(log_handle, &iosb, &fsi, sizeof(FILE_STANDARD_INFORMATION), FileStandardInformation);
-            
+
             if (!NT_SUCCESS(Status)) {
                 ERR("ZwQueryInformationFile returned %08x\n", Status);
-                return;
+                goto end;
             }
-            
+
             fpi.CurrentByteOffset = fsi.EndOfFile;
-            
+
             Status = ZwSetInformationFile(log_handle, &iosb, &fpi, sizeof(FILE_POSITION_INFORMATION), FilePositionInformation);
-            
+
             if (!NT_SUCCESS(Status)) {
                 ERR("ZwSetInformationFile returned %08x\n", Status);
-                return;
+                goto end;
             }
 
-            Status = ZwWriteFile(log_handle, NULL, NULL, NULL, &iosb, delim, strlen(delim), NULL, NULL);
-        
+            Status = ZwWriteFile(log_handle, NULL, NULL, NULL, &iosb, delim, (ULONG)strlen(delim), NULL, NULL);
+
             if (!NT_SUCCESS(Status)) {
                 ERR("ZwWriteFile returned %08x\n", Status);
-                return;
+                goto end;
             }
         }
-        
+
         dateline = ExAllocatePoolWithTag(PagedPool, 256, ALLOC_TAG);
-        
+
         if (!dateline) {
             ERR("out of memory\n");
-            return;
+            goto end;
         }
-        
+
         KeQuerySystemTime(&time);
-        
+
         RtlTimeToTimeFields(&time, &tf);
-        
-        sprintf(dateline, "Starting logging at %04u-%02u-%02u %02u:%02u:%02u\n", tf.Year, tf.Month, tf.Day, tf.Hour, tf.Minute, tf.Second);
 
-        Status = ZwWriteFile(log_handle, NULL, NULL, NULL, &iosb, dateline, strlen(dateline), NULL, NULL);
-        
+        sprintf(dateline, "Starting logging at %04i-%02i-%02i %02i:%02i:%02i\n", tf.Year, tf.Month, tf.Day, tf.Hour, tf.Minute, tf.Second);
+
+        Status = ZwWriteFile(log_handle, NULL, NULL, NULL, &iosb, dateline, (ULONG)strlen(dateline), NULL, NULL);
+
+        ExFreePool(dateline);
+
         if (!NT_SUCCESS(Status)) {
             ERR("ZwWriteFile returned %08x\n", Status);
-            return;
+            goto end;
         }
-        
-        ExFreePool(dateline);
     }
+
+end:
+    ExReleaseResourceLite(&log_lock);
 }
 #endif
 
-NTSTATUS STDCALL DriverEntry(PDRIVER_OBJECT DriverObject, PUNICODE_STRING RegistryPath) {
+_Function_class_(KSTART_ROUTINE)
+#ifdef __REACTOS__
+static void NTAPI degraded_wait_thread(_In_ void* context) {
+#else
+static void degraded_wait_thread(_In_ void* context) {
+#endif
+    KTIMER timer;
+    LARGE_INTEGER delay;
+
+    UNUSED(context);
+
+    KeInitializeTimer(&timer);
+
+    delay.QuadPart = -30000000; // wait three seconds
+    KeSetTimer(&timer, delay, NULL);
+    KeWaitForSingleObject(&timer, Executive, KernelMode, FALSE, NULL);
+
+    TRACE("timer expired\n");
+
+    degraded_wait = FALSE;
+
+    ZwClose(degraded_wait_handle);
+    degraded_wait_handle = NULL;
+
+    PsTerminateSystemThread(STATUS_SUCCESS);
+}
+
+#ifdef __REACTOS__
+NTSTATUS NTAPI AddDevice(PDRIVER_OBJECT DriverObject, PDEVICE_OBJECT PhysicalDeviceObject) {
+#else
+NTSTATUS AddDevice(PDRIVER_OBJECT DriverObject, PDEVICE_OBJECT PhysicalDeviceObject) {
+#endif
+    LIST_ENTRY* le;
     NTSTATUS Status;
+    UNICODE_STRING volname;
+    ULONG i, j;
+    pdo_device_extension* pdode = NULL;
+    PDEVICE_OBJECT voldev;
+    volume_device_extension* vde;
+
+    TRACE("(%p, %p)\n", DriverObject, PhysicalDeviceObject);
+
+    ExAcquireResourceSharedLite(&pdo_list_lock, TRUE);
+
+    le = pdo_list.Flink;
+    while (le != &pdo_list) {
+        pdo_device_extension* pdode2 = CONTAINING_RECORD(le, pdo_device_extension, list_entry);
+
+        if (pdode2->pdo == PhysicalDeviceObject) {
+            pdode = pdode2;
+            break;
+        }
+
+        le = le->Flink;
+    }
+
+    if (!pdode) {
+        WARN("unrecognized PDO %p\n", PhysicalDeviceObject);
+        Status = STATUS_NOT_SUPPORTED;
+        goto end;
+    }
+
+    ExAcquireResourceSharedLite(&pdode->child_lock, TRUE);
+
+    volname.Length = volname.MaximumLength = (USHORT)((wcslen(BTRFS_VOLUME_PREFIX) + 36 + 1) * sizeof(WCHAR));
+    volname.Buffer = ExAllocatePoolWithTag(PagedPool, volname.MaximumLength, ALLOC_TAG); // FIXME - when do we free this?
+
+    if (!volname.Buffer) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto end2;
+    }
+
+    RtlCopyMemory(volname.Buffer, BTRFS_VOLUME_PREFIX, wcslen(BTRFS_VOLUME_PREFIX) * sizeof(WCHAR));
+
+    j = (ULONG)wcslen(BTRFS_VOLUME_PREFIX);
+    for (i = 0; i < 16; i++) {
+        volname.Buffer[j] = hex_digit(pdode->uuid.uuid[i] >> 4); j++;
+        volname.Buffer[j] = hex_digit(pdode->uuid.uuid[i] & 0xf); j++;
+
+        if (i == 3 || i == 5 || i == 7 || i == 9) {
+            volname.Buffer[j] = '-';
+            j++;
+        }
+    }
+
+    volname.Buffer[j] = '}';
+
+    Status = IoCreateDevice(drvobj, sizeof(volume_device_extension), &volname, FILE_DEVICE_DISK,
+                            RtlIsNtDdiVersionAvailable(NTDDI_WIN8) ? FILE_DEVICE_ALLOW_APPCONTAINER_TRAVERSAL : 0, FALSE, &voldev);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IoCreateDevice returned %08x\n", Status);
+        goto end2;
+    }
+
+    voldev->SectorSize = PhysicalDeviceObject->SectorSize;
+    voldev->Flags |= DO_DIRECT_IO;
+
+    vde = voldev->DeviceExtension;
+    vde->type = VCB_TYPE_VOLUME;
+    vde->name = volname;
+    vde->device = voldev;
+    vde->mounted_device = NULL;
+    vde->pdo = PhysicalDeviceObject;
+    vde->pdode = pdode;
+    vde->removing = FALSE;
+    vde->open_count = 0;
+
+    Status = IoRegisterDeviceInterface(PhysicalDeviceObject, &GUID_DEVINTERFACE_VOLUME, NULL, &vde->bus_name);
+    if (!NT_SUCCESS(Status))
+        WARN("IoRegisterDeviceInterface returned %08x\n", Status);
+
+    vde->attached_device = IoAttachDeviceToDeviceStack(voldev, PhysicalDeviceObject);
+
+    pdode->vde = vde;
+
+    if (pdode->removable)
+        voldev->Characteristics |= FILE_REMOVABLE_MEDIA;
+
+    voldev->Flags &= ~DO_DEVICE_INITIALIZING;
+
+    Status = IoSetDeviceInterfaceState(&vde->bus_name, TRUE);
+    if (!NT_SUCCESS(Status))
+        WARN("IoSetDeviceInterfaceState returned %08x\n", Status);
+
+    Status = STATUS_SUCCESS;
+
+end2:
+    ExReleaseResourceLite(&pdode->child_lock);
+
+end:
+    ExReleaseResourceLite(&pdo_list_lock);
+
+    return Status;
+}
+
+_Function_class_(DRIVER_INITIALIZE)
+#ifdef __REACTOS__
+NTSTATUS NTAPI DriverEntry(_In_ PDRIVER_OBJECT DriverObject, _In_ PUNICODE_STRING RegistryPath) {
+#else
+NTSTATUS DriverEntry(_In_ PDRIVER_OBJECT DriverObject, _In_ PUNICODE_STRING RegistryPath) {
+#endif
+    NTSTATUS Status;
     PDEVICE_OBJECT DeviceObject;
     UNICODE_STRING device_nameW;
     UNICODE_STRING dosdevice_nameW;
     control_device_extension* cde;
-    
+    HANDLE regh;
+    OBJECT_ATTRIBUTES oa;
+    ULONG dispos;
+
     InitializeListHead(&uid_map_list);
-    
+    InitializeListHead(&gid_map_list);
+
+#ifdef _DEBUG
+    ExInitializeResourceLite(&log_lock);
+#endif
+    ExInitializeResourceLite(&mapping_lock);
+
     log_device.Buffer = NULL;
     log_device.Length = log_device.MaximumLength = 0;
     log_file.Buffer = NULL;
     log_file.Length = log_file.MaximumLength = 0;
-    
-    read_registry(RegistryPath);
-    
-#ifdef _DEBUG
-    if (debug_log_level > 0)
-        init_logging();
-    
-    log_started = TRUE;
-#endif
 
-    TRACE("DriverEntry\n");
-    
     registry_path.Length = registry_path.MaximumLength = RegistryPath->Length;
     registry_path.Buffer = ExAllocatePoolWithTag(PagedPool, registry_path.Length, ALLOC_TAG);
-    
+
     if (!registry_path.Buffer) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     RtlCopyMemory(registry_path.Buffer, RegistryPath->Buffer, registry_path.Length);
-   
+
+    read_registry(&registry_path, FALSE);
+
+#ifdef _DEBUG
+    if (debug_log_level > 0)
+        init_logging();
+
+    log_started = TRUE;
+#endif
+
+    TRACE("DriverEntry\n");
+
 #ifndef __REACTOS__
     check_cpu();
 #endif
-   
-//    TRACE("check CRC32C: %08x\n", calc_crc32c((UINT8*)"123456789", 9)); // should be e3069283
-    
+
     if (RtlIsNtDdiVersionAvailable(NTDDI_WIN8)) {
         UNICODE_STRING name;
-        tPsIsDiskCountersEnabled PsIsDiskCountersEnabled;
-        
+        tPsIsDiskCountersEnabled fPsIsDiskCountersEnabled;
+
         RtlInitUnicodeString(&name, L"PsIsDiskCountersEnabled");
-        PsIsDiskCountersEnabled = (tPsIsDiskCountersEnabled)MmGetSystemRoutineAddress(&name);
-        
-        if (PsIsDiskCountersEnabled) {
-            diskacc = PsIsDiskCountersEnabled();
-            
+        fPsIsDiskCountersEnabled = (tPsIsDiskCountersEnabled)MmGetSystemRoutineAddress(&name);
+
+        if (fPsIsDiskCountersEnabled) {
+            diskacc = fPsIsDiskCountersEnabled();
+
             RtlInitUnicodeString(&name, L"PsUpdateDiskCounters");
-            PsUpdateDiskCounters = (tPsUpdateDiskCounters)MmGetSystemRoutineAddress(&name);
-            
-            if (!PsUpdateDiskCounters)
+            fPsUpdateDiskCounters = (tPsUpdateDiskCounters)MmGetSystemRoutineAddress(&name);
+
+            if (!fPsUpdateDiskCounters)
                 diskacc = FALSE;
+
+            RtlInitUnicodeString(&name, L"FsRtlUpdateDiskCounters");
+            fFsRtlUpdateDiskCounters = (tFsRtlUpdateDiskCounters)MmGetSystemRoutineAddress(&name);
         }
-        
+
         RtlInitUnicodeString(&name, L"CcCopyReadEx");
-        CcCopyReadEx = (tCcCopyReadEx)MmGetSystemRoutineAddress(&name);
-        
+        fCcCopyReadEx = (tCcCopyReadEx)MmGetSystemRoutineAddress(&name);
+
         RtlInitUnicodeString(&name, L"CcCopyWriteEx");
-        CcCopyWriteEx = (tCcCopyWriteEx)MmGetSystemRoutineAddress(&name);
-        
+        fCcCopyWriteEx = (tCcCopyWriteEx)MmGetSystemRoutineAddress(&name);
+
         RtlInitUnicodeString(&name, L"CcSetAdditionalCacheAttributesEx");
-        CcSetAdditionalCacheAttributesEx = (tCcSetAdditionalCacheAttributesEx)MmGetSystemRoutineAddress(&name);
+        fCcSetAdditionalCacheAttributesEx = (tCcSetAdditionalCacheAttributesEx)MmGetSystemRoutineAddress(&name);
     } else {
-        PsUpdateDiskCounters = NULL;
-        CcCopyReadEx = NULL;
-        CcCopyWriteEx = NULL;
-        CcSetAdditionalCacheAttributesEx = NULL;
+        fPsUpdateDiskCounters = NULL;
+        fCcCopyReadEx = NULL;
+        fCcCopyWriteEx = NULL;
+        fCcSetAdditionalCacheAttributesEx = NULL;
+        fFsRtlUpdateDiskCounters = NULL;
     }
-   
+
     drvobj = DriverObject;
 
     DriverObject->DriverUnload = DriverUnload;
 
+    DriverObject->DriverExtension->AddDevice = AddDevice;
+
     DriverObject->MajorFunction[IRP_MJ_CREATE]                   = (PDRIVER_DISPATCH)drv_create;
     DriverObject->MajorFunction[IRP_MJ_CLOSE]                    = (PDRIVER_DISPATCH)drv_close;
     DriverObject->MajorFunction[IRP_MJ_READ]                     = (PDRIVER_DISPATCH)drv_read;
@@ -4743,15 +5482,17 @@
     DriverObject->MajorFunction[IRP_MJ_FLUSH_BUFFERS]            = (PDRIVER_DISPATCH)drv_flush_buffers;
     DriverObject->MajorFunction[IRP_MJ_QUERY_VOLUME_INFORMATION] = (PDRIVER_DISPATCH)drv_query_volume_information;
     DriverObject->MajorFunction[IRP_MJ_SET_VOLUME_INFORMATION]   = (PDRIVER_DISPATCH)drv_set_volume_information;
-    DriverObject->MajorFunction[IRP_MJ_CLEANUP]                  = (PDRIVER_DISPATCH)drv_cleanup;
     DriverObject->MajorFunction[IRP_MJ_DIRECTORY_CONTROL]        = (PDRIVER_DISPATCH)drv_directory_control;
     DriverObject->MajorFunction[IRP_MJ_FILE_SYSTEM_CONTROL]      = (PDRIVER_DISPATCH)drv_file_system_control;
-    DriverObject->MajorFunction[IRP_MJ_LOCK_CONTROL]             = (PDRIVER_DISPATCH)drv_lock_control;
     DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL]           = (PDRIVER_DISPATCH)drv_device_control;
     DriverObject->MajorFunction[IRP_MJ_SHUTDOWN]                 = (PDRIVER_DISPATCH)drv_shutdown;
-    DriverObject->MajorFunction[IRP_MJ_PNP]                      = (PDRIVER_DISPATCH)drv_pnp;
+    DriverObject->MajorFunction[IRP_MJ_LOCK_CONTROL]             = (PDRIVER_DISPATCH)drv_lock_control;
+    DriverObject->MajorFunction[IRP_MJ_CLEANUP]                  = (PDRIVER_DISPATCH)drv_cleanup;
     DriverObject->MajorFunction[IRP_MJ_QUERY_SECURITY]           = (PDRIVER_DISPATCH)drv_query_security;
     DriverObject->MajorFunction[IRP_MJ_SET_SECURITY]             = (PDRIVER_DISPATCH)drv_set_security;
+    DriverObject->MajorFunction[IRP_MJ_POWER]                    = (PDRIVER_DISPATCH)drv_power;
+    DriverObject->MajorFunction[IRP_MJ_SYSTEM_CONTROL]           = (PDRIVER_DISPATCH)drv_system_control;
+    DriverObject->MajorFunction[IRP_MJ_PNP]                      = (PDRIVER_DISPATCH)drv_pnp;
 
     init_fast_io_dispatch(&DriverObject->FastIoDispatch);
 
@@ -4766,12 +5507,14 @@
         ERR("IoCreateDevice returned %08x\n", Status);
         return Status;
     }
-    
-    devobj = DeviceObject;
-    cde = (control_device_extension*)devobj->DeviceExtension;
-    
+
+    master_devobj = DeviceObject;
+    cde = (control_device_extension*)master_devobj->DeviceExtension;
+
+    RtlZeroMemory(cde, sizeof(control_device_extension));
+
     cde->type = VCB_TYPE_CONTROL;
-    
+
     DeviceObject->Flags &= ~DO_DEVICE_INITIALIZING;
 
     Status = IoCreateSymbolicLink(&dosdevice_nameW, &device_nameW);
@@ -4779,7 +5522,7 @@
         ERR("IoCreateSymbolicLink returned %08x\n", Status);
         return Status;
     }
-    
+
     Status = init_cache();
     if (!NT_SUCCESS(Status)) {
         ERR("init_cache returned %08x\n", Status);
@@ -4786,18 +5529,69 @@
         return Status;
     }
 
-    InitializeListHead(&volumes);
-    InitializeListHead(&pnp_disks);
-    
     InitializeListHead(&VcbList);
     ExInitializeResourceLite(&global_loading_lock);
-    ExInitializeResourceLite(&volumes_lock);
-    
+    ExInitializeResourceLite(&pdo_list_lock);
+
+    InitializeListHead(&pdo_list);
+
+    InitializeObjectAttributes(&oa, RegistryPath, OBJ_CASE_INSENSITIVE | OBJ_KERNEL_HANDLE, NULL, NULL);
+    Status = ZwCreateKey(&regh, KEY_QUERY_VALUE | KEY_ENUMERATE_SUB_KEYS | KEY_NOTIFY, &oa, 0, NULL, REG_OPTION_NON_VOLATILE, &dispos);
+    if (!NT_SUCCESS(Status)) {
+        ERR("ZwCreateKey returned %08x\n", Status);
+        return Status;
+    }
+
+    watch_registry(regh);
+
+    Status = IoReportDetectedDevice(drvobj, InterfaceTypeUndefined, 0xFFFFFFFF, 0xFFFFFFFF,
+                                    NULL, NULL, 0, &cde->buspdo);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IoReportDetectedDevice returned %08x\n", Status);
+        return Status;
+    }
+
+    Status = IoRegisterDeviceInterface(cde->buspdo, &BtrfsBusInterface, NULL, &cde->bus_name);
+    if (!NT_SUCCESS(Status))
+        WARN("IoRegisterDeviceInterface returned %08x\n", Status);
+
+    cde->attached_device = IoAttachDeviceToDeviceStack(DeviceObject, cde->buspdo);
+
+    Status = IoSetDeviceInterfaceState(&cde->bus_name, TRUE);
+    if (!NT_SUCCESS(Status))
+        WARN("IoSetDeviceInterfaceState returned %08x\n", Status);
+
+    DeviceObject->Flags &= ~DO_DEVICE_INITIALIZING;
+
+    IoInvalidateDeviceRelations(cde->buspdo, BusRelations);
+
+    Status = PsCreateSystemThread(&degraded_wait_handle, 0, NULL, NULL, NULL, degraded_wait_thread, NULL);
+    if (!NT_SUCCESS(Status))
+        WARN("PsCreateSystemThread returned %08x\n", Status);
+
     Status = IoRegisterPlugPlayNotification(EventCategoryDeviceInterfaceChange, PNPNOTIFY_DEVICE_INTERFACE_INCLUDE_EXISTING_INTERFACES,
+                                            (PVOID)&GUID_DEVINTERFACE_VOLUME, DriverObject, volume_notification, DriverObject, &notification_entry2);
+    if (!NT_SUCCESS(Status))
+        ERR("IoRegisterPlugPlayNotification returned %08x\n", Status);
+
+    Status = IoRegisterPlugPlayNotification(EventCategoryDeviceInterfaceChange, PNPNOTIFY_DEVICE_INTERFACE_INCLUDE_EXISTING_INTERFACES,
+                                            (PVOID)&GUID_DEVINTERFACE_HIDDEN_VOLUME, DriverObject, volume_notification, DriverObject, &notification_entry3);
+    if (!NT_SUCCESS(Status))
+        ERR("IoRegisterPlugPlayNotification returned %08x\n", Status);
+
+    Status = IoRegisterPlugPlayNotification(EventCategoryDeviceInterfaceChange, PNPNOTIFY_DEVICE_INTERFACE_INCLUDE_EXISTING_INTERFACES,
                                             (PVOID)&GUID_DEVINTERFACE_DISK, DriverObject, pnp_notification, DriverObject, &notification_entry);
     if (!NT_SUCCESS(Status))
         ERR("IoRegisterPlugPlayNotification returned %08x\n", Status);
-    
+
+    finished_probing = TRUE;
+
+    KeInitializeEvent(&mountmgr_thread_event, NotificationEvent, FALSE);
+
+    Status = PsCreateSystemThread(&mountmgr_thread_handle, 0, NULL, NULL, NULL, mountmgr_thread, NULL);
+    if (!NT_SUCCESS(Status))
+        WARN("PsCreateSystemThread returned %08x\n", Status);
+
     IoRegisterFileSystem(DeviceObject);
 
     return STATUS_SUCCESS;
Index: drivers/filesystems/btrfs/btrfs.h
===================================================================
--- drivers/filesystems/btrfs/btrfs.h	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs.h	(copie de travail)
@@ -34,6 +34,9 @@
 #define TYPE_SHARED_BLOCK_REF  0xB6
 #define TYPE_SHARED_DATA_REF   0xB8
 #define TYPE_BLOCK_GROUP_ITEM  0xC0
+#define TYPE_FREE_SPACE_INFO   0xC6
+#define TYPE_FREE_SPACE_EXTENT 0xC7
+#define TYPE_FREE_SPACE_BITMAP 0xC8
 #define TYPE_DEV_EXTENT        0xCC
 #define TYPE_DEV_ITEM          0xD8
 #define TYPE_CHUNK_ITEM        0xE4
@@ -40,6 +43,7 @@
 #define TYPE_TEMP_ITEM         0xF8
 #define TYPE_DEV_STATS         0xF9
 #define TYPE_SUBVOL_UUID       0xFB
+#define TYPE_SUBVOL_REC_UUID   0xFC
 
 #define BTRFS_ROOT_ROOT         1
 #define BTRFS_ROOT_EXTENT       2
@@ -48,6 +52,7 @@
 #define BTRFS_ROOT_FSTREE       5
 #define BTRFS_ROOT_CHECKSUM     7
 #define BTRFS_ROOT_UUID         9
+#define BTRFS_ROOT_FREE_SPACE   0xa
 #define BTRFS_ROOT_DATA_RELOC   0xFFFFFFFFFFFFFFF7
 
 #define BTRFS_COMPRESSION_NONE  0
@@ -91,7 +96,8 @@
 
 #define BTRFS_SUBVOL_READONLY   0x1
 
-#define BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE  0x1
+#define BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE          0x1
+#define BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE_VALID    0x2
 
 #define BTRFS_INCOMPAT_FLAGS_MIXED_BACKREF      0x0001
 #define BTRFS_INCOMPAT_FLAGS_DEFAULT_SUBVOL     0x0002
@@ -495,6 +501,85 @@
     UINT8 reserved[32];
 } BALANCE_ITEM;
 
+#define BTRFS_FREE_SPACE_USING_BITMAPS      1
+
+typedef struct {
+    UINT32 count;
+    UINT32 flags;
+} FREE_SPACE_INFO;
+
+#define BTRFS_DEV_STAT_WRITE_ERRORS          0
+#define BTRFS_DEV_STAT_READ_ERRORS           1
+#define BTRFS_DEV_STAT_FLUSH_ERRORS          2
+#define BTRFS_DEV_STAT_CORRUPTION_ERRORS     3
+#define BTRFS_DEV_STAT_GENERATION_ERRORS     4
+
+#define BTRFS_SEND_CMD_SUBVOL          1
+#define BTRFS_SEND_CMD_SNAPSHOT        2
+#define BTRFS_SEND_CMD_MKFILE          3
+#define BTRFS_SEND_CMD_MKDIR           4
+#define BTRFS_SEND_CMD_MKNOD           5
+#define BTRFS_SEND_CMD_MKFIFO          6
+#define BTRFS_SEND_CMD_MKSOCK          7
+#define BTRFS_SEND_CMD_SYMLINK         8
+#define BTRFS_SEND_CMD_RENAME          9
+#define BTRFS_SEND_CMD_LINK           10
+#define BTRFS_SEND_CMD_UNLINK         11
+#define BTRFS_SEND_CMD_RMDIR          12
+#define BTRFS_SEND_CMD_SET_XATTR      13
+#define BTRFS_SEND_CMD_REMOVE_XATTR   14
+#define BTRFS_SEND_CMD_WRITE          15
+#define BTRFS_SEND_CMD_CLONE          16
+#define BTRFS_SEND_CMD_TRUNCATE       17
+#define BTRFS_SEND_CMD_CHMOD          18
+#define BTRFS_SEND_CMD_CHOWN          19
+#define BTRFS_SEND_CMD_UTIMES         20
+#define BTRFS_SEND_CMD_END            21
+#define BTRFS_SEND_CMD_UPDATE_EXTENT  22
+
+#define BTRFS_SEND_TLV_UUID             1
+#define BTRFS_SEND_TLV_TRANSID          2
+#define BTRFS_SEND_TLV_INODE            3
+#define BTRFS_SEND_TLV_SIZE             4
+#define BTRFS_SEND_TLV_MODE             5
+#define BTRFS_SEND_TLV_UID              6
+#define BTRFS_SEND_TLV_GID              7
+#define BTRFS_SEND_TLV_RDEV             8
+#define BTRFS_SEND_TLV_CTIME            9
+#define BTRFS_SEND_TLV_MTIME           10
+#define BTRFS_SEND_TLV_ATIME           11
+#define BTRFS_SEND_TLV_OTIME           12
+#define BTRFS_SEND_TLV_XATTR_NAME      13
+#define BTRFS_SEND_TLV_XATTR_DATA      14
+#define BTRFS_SEND_TLV_PATH            15
+#define BTRFS_SEND_TLV_PATH_TO         16
+#define BTRFS_SEND_TLV_PATH_LINK       17
+#define BTRFS_SEND_TLV_OFFSET          18
+#define BTRFS_SEND_TLV_DATA            19
+#define BTRFS_SEND_TLV_CLONE_UUID      20
+#define BTRFS_SEND_TLV_CLONE_CTRANSID  21
+#define BTRFS_SEND_TLV_CLONE_PATH      22
+#define BTRFS_SEND_TLV_CLONE_OFFSET    23
+#define BTRFS_SEND_TLV_CLONE_LENGTH    24
+
+#define BTRFS_SEND_MAGIC "btrfs-stream\0"
+
+typedef struct {
+    UINT8 magic[13];
+    UINT32 version;
+} btrfs_send_header;
+
+typedef struct {
+    UINT32 length;
+    UINT16 cmd;
+    UINT32 csum;
+} btrfs_send_command;
+
+typedef struct {
+    UINT16 type;
+    UINT16 length;
+} btrfs_send_tlv;
+
 #pragma pack(pop)
 
 #endif
Index: drivers/filesystems/btrfs/btrfs.rc
===================================================================
--- drivers/filesystems/btrfs/btrfs.rc	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs.rc	(copie de travail)
@@ -7,7 +7,7 @@
 //
 // Generated from the TEXTINCLUDE 2 resource.
 //
-#include "afxres.h"
+#include "winres.h"
 
 /////////////////////////////////////////////////////////////////////////////
 #undef APSTUDIO_READONLY_SYMBOLS
@@ -27,18 +27,18 @@
 // TEXTINCLUDE
 //
 
-1 TEXTINCLUDE 
+1 TEXTINCLUDE
 BEGIN
     "resource.h\0"
 END
 
-2 TEXTINCLUDE 
+2 TEXTINCLUDE
 BEGIN
-    "#include ""afxres.h""\r\n"
+    "#include ""winres.h""\r\n"
     "\0"
 END
 
-3 TEXTINCLUDE 
+3 TEXTINCLUDE
 BEGIN
     "\r\n"
     "\0"
@@ -70,12 +70,12 @@
         BLOCK "080904b0"
         BEGIN
             VALUE "FileDescription", "WinBtrfs"
-            VALUE "FileVersion", "0.8"
+            VALUE "FileVersion", "1.0"
             VALUE "InternalName", "btrfs"
-            VALUE "LegalCopyright", "Copyright (c) Mark Harmstone 2016"
+            VALUE "LegalCopyright", "Copyright (c) Mark Harmstone 2016-17"
             VALUE "OriginalFilename", "btrfs.sys"
             VALUE "ProductName", "WinBtrfs"
-            VALUE "ProductVersion", "0.8"
+            VALUE "ProductVersion", "1.0"
         END
     END
     BLOCK "VarFileInfo"
